<?php
////////////////////////////////////////////////////////////////
//¤
// File:      FAST 3.2 (First Automatic Server for Trackmania)
// Web:       
// Date:      18.06.2010
// Author:    Gilles Masson
// 
////////////////////////////////////////////////////////////////
//
// FAST3.2 plugin to handle script specific FastGameMode : TeamLaps
// (needs the fteams and fgmodes plugins)
//
registerPlugin('fteamlaps',52,1.0);

// 
// FastGameMode TeamLaps, Laps team race
//_NextFGameMode=fteamsBuildScore()
function fteamlapsInit($event){
	global $_debug,$_players,$_FGameModes,$_FGameMode,$_NextFGameMode;
	if($_debug>6) console("players.Event[$event]");

	// Add/Set GameInfos constants for Teamlaps FGameMode(see plugin.17.fgmodes.php) :
	$_FGameModes['TeamLaps']['Aliases'] = array('tlaps','tla','tl'); // mode name is not case sensitive, but aliases are.
	$_FGameModes['TeamLaps']['Podium'] = true;
	$_FGameModes['TeamLaps']['ScoreMode'] = 'Score';
	$_FGameModes['TeamLaps']['RoundPanel'] = true;
	$_FGameModes['TeamLaps']['FTeams'] = true;
	$_FGameModes['TeamLaps']['PointsRule'] = 'incremental'; // round points for players
	$_FGameModes['TeamLaps']['RanksRule'] = 'Points';  // team round ranks based on players points sum
	$_FGameModes['TeamLaps']['ScoresRule'] = 'points'; // team score is team points
	$_FGameModes['TeamLaps']['GameInfos'] = array('GameMode'=>3);

	// max players by team who are counted
	if(!isset($_FGameModes['TeamLaps']['TeamMaxPlayers']))
		$_FGameModes['TeamLaps']['TeamMaxPlayers'] = 3;

	//$_FGameModes['TeamLaps']['Set'] = array();
	//$_FGameModes['TeamLaps']['Next'] = array();
	//$_FGameModes['TeamLaps']['Current'] = array();

	registerCommand('tlaps','/tlaps ',true);
	registerCommand('teamlaps','/tlaps ',true);
}

function fteamlapsBuildRoundPanel($refresh=false,$endround=false){
	global $_debug,$_players,$_fteams_max,$_fteams_rules,$_fteams,$_fteams_round,$_teambgcolor,$_FGameModes,$_FGameMode,$_teambgcolor,$_players_positions;

	$scores = array();
	$scores2 = array();
	
	$col1 = $endround ? '' : '$aa8';
	$col2 = $endround ? '' : '$8a8';

	foreach($_fteams_round as $ftid => $ftr){
		if($_fteams[$ftid]['Active']){
			$scores[] = array('fgmodes.'.$ftid,$_teambgcolor[$ftid],$col1.$ftr['RoundPoints'],$col2.'+'.$ftr['RoundScore'],$_fteams[$ftid]['NameDraw']);
		}
	}

	if(count($_players_positions) > 0){
		foreach($_players_positions as $i => $plp){
			$ftid = $plp['FTeamId'];
			$login = $plp['Login'];
			if($plp['FinalTime'] == 0){
				$strtime = 'out';
			}else{
				if($i <= 0){
					// first
					if($plp['FinalTime'] > 0)
						$strtime = MwTimeToString($plp['FinalTime']);
					else
						$strtime = MwTimeToString($plp['Time']);
				}else{
					// other
					$position = &$_players[$login]['Position'];
					if($position['FirstDiffCheck'] < 0)
						$strtime = '+'.(-$position['FirstDiffCheck']).'cp ('.MwDiffTimeToString(-$position['FirstDiffTime']).')';
					else
						$strtime = MwDiffTimeToString(-$position['FirstDiffTime']);
				}
			}
			
			if($plp['FinalTime'] >= 0)
				$scores2[] = array('fgmodes.'.$ftid,$_teambgcolor[$ftid],$plp['FTeamPoints'],$strtime,$_players[$login]['NickDraw4']);
			else
				$scores2[] = array('fgmodes.'.$ftid,$_teambgcolor[$ftid],$col1.$plp['FTeamPoints'],$col2.$strtime,'$bbb'.$plp['NickDraw2']);
		}
	}
	/*
	$scores = array(array('fgmodes.0','fff',218,'+10','TX1'),
									array('fgmodes.1','f00',118,'+5','Tra$ff0Xico'),
									array('fgmodes.2','0f0',56,'+2','LSD1'),
									);

	$scores2 = array(array('fgmodes.0','fff',24,'03:12.34','TX-Slig'),
									 array('fgmodes.1','f0f','0','','$iGogogo for life'),
									 array('fgmodes.2','00f',54,'+1','$oLSD1'),
									 array('fgmodes.2','ff0',52,'+0','$wLSD1'),
									 array('fgmodes.1','0ff',20,'','$sLSD1'),
									 array('fgmodes.0','fff','0','','$iGogogo for life'),
									 array('fgmodes.1','000','0','','$iGogogo for life'),
									 array('fgmodes.2','f00','+0','+0.23','LSD-Arkone'),
									 array('fgmodes.2','ff0','+2','+4.80','Mike'),
									 array('fgmodes.1','0ff','+2','+5.12','Schum'),
									 array('fgmodes.0x','0f0','','+1.10','bubule'),
									 array('fgmodes.1x','00f','+1','+2.50','alonso'),
									 array('fgmodes.1x','f0f','+5','+14.23','Delnuelo'),
									 );
	*/
	fgmodesSetRoundScore($scores,$scores2,0,1,$refresh);
}

function fteamlapsBeginRace($event,$GameInfos,$ChallengeInfo,$newcup,$warmup,$fwarmup){
	global $_debug,$_FGameMode;

	if($_FGameMode != 'TeamLaps')
		return;
	if($_debug>6) console("fteamlaps.Event[$event]($newcup,$warmup,$fwarmup)");

	fteamsBuildScore();
}

function fteamlapsBeginRound($event){
	global $_debug,$_FGameMode;
	if($_FGameMode != 'TeamLaps')
		return;
	if($_debug>6) console("fteamlaps.Event[$event]");
}

function fteamlapsPlayerConnect($event,$login){
	global $_debug,$_FGameMode;
	if($_FGameMode != 'TeamLaps')
		return;
	if($_debug>6) console("fteamlaps.Event[$event]('$login')");
}

function fteamlapsPlayerDisconnect($event,$login){
	global $_debug,$_FGameMode;
	if($_FGameMode != 'TeamLaps')
		return;
	if($_debug>6) console("fteamlaps.Event[$event]('$login')");
}

function fteamlapsPlayerCheckpoint($event,$login,$time,$lapnum,$checkpt){
	global $_debug,$_FGameMode;
	if($_FGameMode != 'TeamLaps')
		return;
	if($_debug>6) console("fteamlaps.Event[$event]('$login',$time,$lapnum,$checkpt)");
}

function fteamlapsPlayerPositionChange($event,$login,$changes){
	global $_debug,$_FGameMode;
	if($_FGameMode != 'TeamLaps' || $login !== true)
		return;

	fteamlapsBuildRoundPanel(true);
}

function fteamlapsBeforeEndRound($event,$delay){
	global $_debug,$_FGameMode,$_players,$_fteams,$_fteams_round;
	if($_FGameMode != 'TeamLaps')
		return;

	if($delay < 0){ // (final call)

		//fteamlapsBuildRoundPanel(true,true);
	}
}

function fteamlapsEndRound($event,$Ranking,$ChallengeInfo,$GameInfos,$SpecialRestarting){
	global $_debug,$_FGameMode;
	if($_FGameMode != 'TeamLaps')
		return;
	if($_debug>6) console("fteamlaps.Event[$event]");

	fteamlapsBuildRoundPanel(true,true);
}

function fteamlapsEndRace($event,$Ranking,$ChallengeInfo,$GameInfos,$continuecup,$warmup,$fwarmup){
	global $_debug,$_FGameMode;
	if($_FGameMode != 'TeamLaps')
		return;
	if($_debug>6) console("fteamlaps.Event[$event]($continuecup,$warmup,$fwarmup)");
}


//------------------------------------------
// tlaps Commands
//------------------------------------------
function chat_tlaps($author, $login, $params, $params2){
	global $_debug,$_fteams,$_fteams_maxid;

	goNotStunts();

	//if(!verifyAdmin($login)){ }
	$msg = localeText(null,'server_message') . localeText(null,'interact');

	if(!isset($params[0]))
		$params[0] = 'help';

	if($params[0] == 'join'){
	}
}

function chat_teamlaps($author, $login, $params, $params2){
	chat_tlaps($author, $login, $params, $params2);
}


?>
